<?php

/**
*
* @package Double Account Preventer
* @copyright (c) 2009 kmklr72, 2013 www.phpbb-work.ru
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_dap
{
	var $u_action;

	function main($id, $mode)
	{
		global $auth, $dap, $db, $user, $template, $phpbb_root_path, $phpEx;

		$action = request_var('action', '');
		$form_key = 'acp_dap';
		add_form_key($form_key);

		switch ($mode)
		{
			case 'settings':

				$display_vars = array(
					'title'	=> 'ACP_DAP_SETTINGS',
					'vars'	=> array(
						'legend1'						=> 'ACP_DAP_SETTINGS',
						'dap_ip_check'				=> array('lang' => 'IP_CHECK_REGISTRATION', 'validate' => 'int', 'type' => 'custom', 'method' => 'select_ip_check_registration', 'explain' => true),
						'dap_cookie_check'			=> array('lang' => 'COOKIE_CHECK_REGISTRATION', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
						'dap_ignore_inactive'			=> array('lang' => 'DAP_IGNORE_INACTIVE', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
						'dap_quick_deletion'			=> array('lang' => 'DAP_QUICK_DELETION', 'validate' => 'int', 'type' => 'custom', 'method' => 'select_quick_deletion', 'explain' => true),
						'dap_users_per_page'					=> array('lang' => 'DAP_DUPLICATES_PER_PAGE', 'validate' => 'int:1', 'type' => 'text:10:10', 'explain' => true),

						'legend2'						=> 'ACP_DAP_COOKIE_BAN_SETTINGS',
						'dap_cookie_ban'			=> array('lang' => 'DAP_COOKIE_BAN_ENABLED', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
						'dap_cookie_autoban'			=> array('lang' => 'DAP_COOKIE_AUTOBAN_ENABLED', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
						'dap_cookie_ban_message'			=> array('lang' => 'DAP_COOKIE_BAN_MESSAGE', 'validate' => 'string', 'type' => 'text:40:255', 'explain' => true),
						'dap_cookie_reg_deny'			=> array('lang' => 'DAP_COOKIE_DENY_REGISTER', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
						'dap_reg_deny_message'			=> array('lang' => 'DAP_COOKIE_DENY_MESSAGE', 'validate' => 'string', 'type' => 'text:40:255', 'explain' => true),

						'legend3'						=> 'ACP_DAP_NOTIFICATIONS',
						'dap_post_forum_id'			=> array('lang' => 'DAP_POST_NOTIFICATION', 'validate' => 'string', 'type' => 'custom', 'method' => 'select_notify_forums', 'explain' => true),
						'dap_pm_notification'		=> array('lang' => 'DAP_PM_NOTIFICATION', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
						'dap_alert_user_id'					=> array('lang' => 'DAP_ALERT_USER_ID', 'validate' => 'int', 'type' => 'text:10:10', 'explain' => true),
						'dap_user_notes_entry'		=> array('lang' => 'DAP_USER_NOTES_ENTRY', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
						'dap_email_notification'		=> array('lang' => 'DAP_EMAIL_NOTIFICATION', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
					)
				);

				$template->assign_vars(array(
					'SETTINGS'		=> true,
				));

				$this->page_output($display_vars, $form_key);
			break;

			case 'dupe_user_list':

				$display_vars = array(
					'title' => 'ACP_DAP_DUPE_USER_LIST',
				);

				$template->assign_vars(array(
					'L_TITLE'			=> $user->lang[$display_vars['title']],
					'L_TITLE_EXPLAIN'	=> $user->lang[$display_vars['title'] . '_EXPLAIN'],

					'DUPE_USER_LIST'		=> true,
				));

				if (isset($_GET['ban']))
				{
					$ban = request_var('ban', 0);
					$start = request_var('start', 0);
					$user_id = request_var('u', 0);

					$sql = 'SELECT username, user_type, user_banned_cookie
						FROM ' . USERS_TABLE . '
						WHERE user_id = ' . (int) $user_id;
					$result = $db->sql_query($sql);
					$row = $db->sql_fetchrow($result);
					$db->sql_freeresult($result);

					if (!$auth->acl_get('a_ban'))
					{
						trigger_error($user->lang['ACP_DAP_NO_PERMISSIONS'] . adm_back_link($this->u_action . '&amp;start=' . $start), E_USER_WARNING);
					}
					else if ($user_id == ANONYMOUS && $ban)
					{
						trigger_error($user->lang['DAP_CANNOT_BAN_ANONYMOUS'] . adm_back_link($this->u_action . '&amp;start=' . $start), E_USER_WARNING);
					}
					else if ($user_id == $user->data['user_id'] && $ban)
					{
						trigger_error($user->lang['DAP_CANNOT_BAN_YOURSELF'] . adm_back_link($this->u_action . '&amp;start=' . $start), E_USER_WARNING);
					}
					else if ($row['user_type'] == USER_FOUNDER && $ban)
					{
						trigger_error($user->lang['DAP_CANNOT_BAN_FOUNDER'] . adm_back_link($this->u_action . '&amp;start=' . $start), E_USER_WARNING);
					}
					else if ($row['user_type'] == USER_IGNORE && $ban)
					{
						trigger_error($user->lang['DAP_CANNOT_BAN_BOT'] . adm_back_link($this->u_action . '&amp;start=' . $start), E_USER_WARNING);
					}
					else
					{
						if ($ban != $row['user_banned_cookie'])
						{
							$dap->cookie_ban_user($user_id, $ban);
							$ban_status = $this->ban_status($ban);

							add_log('admin', $ban_status['log_entry'], $row['username']);
							add_log('mod', 0, 0, $ban_status['log_entry'], $row['username']);
							add_log('user', $user_id, $ban_status['log_entry'], $row['username']);
						}
					}
				}

				$this->list_dupe_users();
			break;

			case 'dupe_log':

				$display_vars = array(
					'title' => 'ACP_DAP_DUPE_LOG',
				);

				$template->assign_vars(array(
					'L_TITLE'			=> $user->lang[$display_vars['title']],
					'L_TITLE_EXPLAIN'	=> $user->lang[$display_vars['title'] . '_EXPLAIN'],

					'DUPE_LOG'		=> true,
				));

				$this->dupe_log();
			break;

			case 'dap_blacklist':

				$display_vars = array(
					'title' => 'ACP_DAP_BLACKLIST',
				);

				$template->assign_vars(array(
					'L_TITLE'			=> $user->lang[$display_vars['title']],
					'L_TITLE_EXPLAIN'	=> $user->lang[$display_vars['title'] . '_EXPLAIN'],

					'BLACKLIST'		=> true,
				));

				$this->cookie_blacklist();
			break;

			default:
				trigger_error('NO_MODE', E_USER_ERROR);
			break;
		}

		if ($action == 'whois')
		{
			include($phpbb_root_path . 'includes/functions_user.' . $phpEx);

			$user->add_lang('acp/users');
			$this->page_title = 'WHOIS';
			$this->tpl_name = 'simple_body';

			$user_ip = request_var('user_ip', '');
			$domain = gethostbyaddr($user_ip);
			$ipwhois = user_ipwhois($user_ip);

			$template->assign_vars(array(
				'MESSAGE_TITLE'		=> sprintf($user->lang['IP_WHOIS_FOR'], $domain),
				'MESSAGE_TEXT'		=> nl2br($ipwhois))
			);

			return;
		}
		else
		{
			$this->tpl_name = 'acp_dap';
			$this->page_title = $user->lang[$display_vars['title']];
		}
	}

	function select_ip_check_registration($value, $key = '')
	{
		$radio_ary = array(0 => 'IP_CHECK_NONE', 1 => 'IP_CHECK_LIGHT', 2 => 'IP_CHECK_FULL');	

		return h_radio('config[dap_ip_check]', $radio_ary, $value, 'dap_ip_check', $key, '<br />');
	}

	function select_quick_deletion($value, $key = '')
	{
		$radio_ary = array(0 => 'NO', 1 => 'QUICK_DELETE_SILENT', 2 => 'QUICK_DELETE_NOTIFY');

		return h_radio('config[dap_quick_deletion]', $radio_ary, $value, 'dap_quick_deletion', $key, '<br />');
	}

	function select_notify_forums()
	{
		global $config;

		return '<select id="dap_post_forum_id" name="dap_post_forum_id[]" multiple="multiple">' . make_forum_select(explode(',', $config['dap_post_forum_id']), false, false, true) . '</select>';
	}

	function ban_status($ban, $count = false)
	{
		global $user;

		$ban_status = array();

		if (empty($ban))
		{
			$ban = 1;
			$ban_color = '';
			$log_entry = ($count) ? 'LOG_COOKIE_UNBAN_MANY' : 'LOG_COOKIE_UNBAN';
			$status = '';
		}
		else if ($ban == 1)
		{
			$ban = 2;
			$ban_color = ' style="color: red;"';
			$log_entry = ($count) ? 'LOG_COOKIE_BLACKLIST_MANY' : 'LOG_COOKIE_BLACKLIST';
			$status = '<p style="color: red; padding-top: 6px;">' . $user->lang['DAP_STATUS_BLACKLIST'] . '</p>';
		}
		else if ($ban == 2)
		{
			$ban = 3;
			$ban_color = ' style="color: green;"';
			$log_entry = ($count) ? 'LOG_COOKIE_WHITELIST_MANY' : 'LOG_COOKIE_WHITELIST';
			$status = '<p style="color: green; padding-top: 6px;">' . $user->lang['DAP_STATUS_WHITELIST'] . '</p>';
		}
		else
		{
			$ban = 0;
			$ban_color = ' style="color: blue;"';
			$log_entry = ($count) ? 'LOG_COOKIE_EXCLUSION_MANY' : 'LOG_COOKIE_EXCLUSION';
			$status = '<p style="color: blue; padding-top: 6px;">' . $user->lang['DAP_STATUS_EXCLUSION'] . '</p>';
		}

		$ban_status = array(
			'ban'			=> $ban,
			'ban_color'		=> $ban_color,
			'status'		=> $status,
			'log_entry'		=> $log_entry,
		);

		return $ban_status;
	}

	function dap_delete_user($user_id, $delposts, $start)
	{
		global $config, $db, $auth, $user, $phpbb_root_path, $phpEx;

		$sql = 'SELECT user_id, username, user_type, user_email, user_lang, user_jabber, user_notify_type
			FROM ' . USERS_TABLE . '
			WHERE user_id = ' . (int) $user_id;
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		if ($row['user_id'] == $user->data['user_id'])
		{
			trigger_error($user->lang['CANNOT_REMOVE_YOURSELF'] . adm_back_link($this->u_action . '&amp;start=' . $start), E_USER_WARNING);
		}

		if ($row['user_id'] == ANONYMOUS)
		{
			trigger_error($user->lang['CANNOT_REMOVE_ANONYMOUS'] . adm_back_link($this->u_action . '&amp;start=' . $start), E_USER_WARNING);
		}

		if ($row['user_type'] == USER_FOUNDER)
		{
			trigger_error($user->lang['CANNOT_REMOVE_FOUNDER'] . adm_back_link($this->u_action . '&amp;start=' . $start), E_USER_WARNING);
		}

		if (!function_exists('user_delete'))
		{
			include($phpbb_root_path . 'includes/functions_user.' . $phpEx);
		}

		if ($config['dap_quick_deletion'] == 2)
		{
			include_once($phpbb_root_path . 'includes/functions_messenger.' . $phpEx);

			$messenger = new messenger(false);

			$messenger->template('user_dap_deleted', $row['user_lang']);
			$messenger->to($row['user_email'], $row['username']);
			$messenger->im($row['user_jabber'], $row['username']);

			// Email headers
			$messenger->anti_abuse_headers($config, $user);

			$messenger->assign_vars(array(
				'BOARD_CONTACT'		=> $config['board_contact'],
				'USERNAME'			=> htmlspecialchars_decode($row['username']),
			));

			$messenger->send($row['user_notify_type']);
		}

		$delete_type = ($delposts) ? 'remove' : 'retain';

		user_delete($delete_type, $user_id, $row['username']);

		add_log('admin', 'LOG_USER_DELETED', $row['username']);
	}

	function cookie_blacklist()
	{
		global $user, $db, $template, $phpbb_root_path, $phpEx;

		// request vars
		$useradd	= request_var('useradd', false);
		$userfree	= request_var('userfree', false);

		// form key
		$form_key = 'dap_blacklist';
		add_form_key($form_key);

		if (($useradd || $userfree) && !check_form_key($form_key))
		{
			trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
		}

		// User submitted?
		if ($useradd)
		{
			$usernames = array_map('trim', explode("\n", utf8_normalize_nfc(request_var('names', '', true))));
			$ban = request_var('ban_mode', '');

			$banlist_ary = $bot_names = $founder_names = $full_usernames = $sql_usernames = array();

			// Create a list of founders and bots...
			$sql = 'SELECT user_id, user_type, username_clean
				FROM ' . USERS_TABLE . '
				WHERE user_type = ' . USER_FOUNDER . '
					OR user_type = ' . USER_IGNORE;
			$result = $db->sql_query($sql);

			while ($row = $db->sql_fetchrow($result))
			{
				if ($row['user_type'] == USER_FOUNDER)
				{
					$founder_names[$row['user_id']] = $row['username_clean'];
				}
				if ($row['user_type'] == USER_IGNORE && $row['user_id'] != ANONYMOUS)
				{
					$bot_names[$row['user_id']] = $row['username_clean'];
				}
			}
			$db->sql_freeresult($result);

			foreach ($usernames as $username)
			{
				$username = trim($username);
				if ($username != '')
				{
					$clean_name = utf8_clean_string($username);
					if ($clean_name == $user->data['username_clean'])
					{
						trigger_error($user->lang['DAP_CANNOT_BAN_YOURSELF'] . adm_back_link($this->u_action), E_USER_WARNING);
					}
					if (in_array($clean_name, $founder_names))
					{
						trigger_error($user->lang['DAP_CANNOT_BAN_FOUNDER'] . adm_back_link($this->u_action), E_USER_WARNING);
					}
					if (in_array($clean_name, $bot_names))
					{
						trigger_error($user->lang['DAP_CANNOT_BAN_BOT'] . adm_back_link($this->u_action), E_USER_WARNING);
					}
					$sql_usernames[] = $clean_name;
				}
			}

			// Make sure we have been given someone to ban
			if (!sizeof($sql_usernames))
			{
				trigger_error($user->lang['NO_USER_SPECIFIED'] . adm_back_link($this->u_action), E_USER_WARNING);
			}

			$sql = 'SELECT user_id, username
				FROM ' . USERS_TABLE . '
				WHERE ' . $db->sql_in_set('username_clean', $sql_usernames);

			// Do not allow banning yourself, the guest account, or founders.
			$non_bannable = array($user->data['user_id'], ANONYMOUS);

			$sql .= ' AND ' . $db->sql_in_set('user_id', $non_bannable, true);

			unset($sql_usernames, $non_bannable);

			$result = $db->sql_query($sql);

			if ($row = $db->sql_fetchrow($result))
			{
				do
				{
					$banlist_ary[] = (int) $row['user_id'];
					$full_usernames[] = $row['username'];
				}
				while ($row = $db->sql_fetchrow($result));

				$sql = 'UPDATE ' . USERS_TABLE . '
					SET user_banned_cookie = ' . (int) $ban . '
					WHERE ' . $db->sql_in_set('user_id', $banlist_ary);
				$db->sql_query($sql);
			}
			else
			{
				$db->sql_freeresult($result);
				trigger_error($user->lang['NO_USERS'] . adm_back_link($this->u_action), E_USER_WARNING);
			}
			$db->sql_freeresult($result);

			$ban_list = (!is_array($full_usernames)) ? array_unique(explode("\n", $full_usernames)) : $full_usernames;
			$ban_list_log = implode(', ', $ban_list);

			unset($full_usernames, $founder_names, $bot_names);

			// Add to moderator log, admin log and user notes
			$count = (sizeof($ban_list) > 1) ? 1 : 0;
			$ban_status = $this->ban_status($ban, $count);

			add_log('admin', $ban_status['log_entry'], $ban_list_log);
			add_log('mod', 0, 0, $ban_status['log_entry'], $ban_list_log);

			foreach ($banlist_ary as $user_id)
			{
				add_log('user', $user_id, $ban_status['log_entry'], $ban_list_log);
			}

			unset($banlist_ary);

			trigger_error($user->lang['ACP_DAP_BLACKLIST_UPDATED'] . adm_back_link($this->u_action));
		}
		else if ($userfree)
		{
			$user_id = request_var('userlist', array(0 => ''));

			if ($user_id)
			{
				$unban_names = array();

				$sql_where = (is_array($user_id)) ? $db->sql_in_set('user_id', array_map('intval', $user_id)) : 'user_id = ' . (int) $user_id;

				$sql = 'UPDATE ' . USERS_TABLE . '
					SET user_banned_cookie = ' . (int) 0 . '
					WHERE ' . $sql_where;
				$db->sql_query($sql);

				$sql = 'SELECT username
					FROM ' . USERS_TABLE . '
					WHERE ' . $sql_where;
				$result = $db->sql_query($sql);

				while ($row = $db->sql_fetchrow($result))
				{
					$unban_names[] = $row['username'];
				}
				$db->sql_freeresult($result);

				$ban_list_log = implode(', ', $unban_names);
				$log_entry = (sizeof($unban_names) > 1) ? 'LOG_COOKIE_UNBAN_MANY' : 'LOG_COOKIE_UNBAN';

				unset($unban_names);

				add_log('admin', $log_entry, $ban_list_log);
				add_log('mod', 0, 0, $log_entry, $ban_list_log);

				foreach ($user_id as $id)
				{
					add_log('user', $id, $log_entry, $ban_list_log);
				}

				trigger_error($user->lang['ACP_DAP_BLACKLIST_UPDATED'] . adm_back_link($this->u_action));
			}
		}

		// select all users
		$sql = 'SELECT user_id, username, user_banned_cookie
			FROM ' . USERS_TABLE . '
			WHERE user_banned_cookie > 0
				ORDER BY username_clean ASC';
		$result = $db->sql_query($sql);

		$user_options = '';
		while ($row = $db->sql_fetchrow($result))
		{
			$ban_status = $this->ban_status($row['user_banned_cookie']);
			$user_options .= '<option' . $ban_status['ban_color'] . ' value="' . $row['user_id'] . '">' . $row['username']  . '</option>';
		}
		$db->sql_freeresult($result);

		// template vars
		$template->assign_vars(array(
			'USER_OPTIONS'			=> $user_options,

			'U_ACTION'				=> $this->u_action,
			'U_FIND_USERNAME'		=> append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=searchuser&amp;form=dap_blacklist&amp;field=names'),
		));
	}

	function dupe_log()
	{
		global $auth, $config, $db, $user, $template, $phpbb_root_path, $phpEx;

		// Set up general vars
		$action		= request_var('action', '');
		$start		= request_var('start', 0);
		$deletetime	= (!empty($_POST['deltime'])) ? true : false;
		$deletemark	= (!empty($_POST['delmarked'])) ? true : false;
		$deleteall	= (!empty($_POST['delall'])) ? true : false;
		$deletedays	= max(0, request_var('deldays', 0));
		$marked		= request_var('mark', array(0));
		$del 		= request_var('del', 0);
		$user_id 	= request_var('u', 0);
		$can_delete	= ($config['dap_quick_deletion'] && $auth->acl_get('a_userdel')) ? true : false;
		$delposts	= request_var('delposts', '');

		// Sort keys
		$sort_days	= request_var('st', 0);
		$sort_key	= request_var('sk', 't');
		$sort_dir	= request_var('sd', 'd');

		$this->log_type = constant('LOG_DAP');

		// Delete entries if requested and able
		if (($del && $can_delete) || (($deletetime || $deletemark || $deleteall) && $auth->acl_get('a_clearlogs')))
		{
			if (confirm_box(true))
			{
				$where_sql = '';

				if ($deletedays)
				{
					$unitime = time() - ($deletedays * 86400);
					$where_sql = ' AND log_time < ' . $unitime;
				}

				if ($deletemark && sizeof($marked))
				{
					$sql_in = array();
					foreach ($marked as $mark)
					{
						$sql_in[] = $mark;
					}
					$where_sql = ' AND ' . $db->sql_in_set('log_id', $sql_in);
					unset($sql_in);
				}

				if ($where_sql || $deleteall)
				{
					$sql = 'DELETE FROM ' . LOG_TABLE . "
						WHERE log_type = {$this->log_type}
						$where_sql";
					$db->sql_query($sql);

					$affected_rows = $db->sql_affectedrows();

					if ($affected_rows)
					{
						add_log('admin', 'LOG_CLEAR_DAP');
					}
					else
					{
						trigger_error($user->lang['ACP_DAP_NO_MATCHES'] . adm_back_link($this->u_action . '&amp;start=' . $start), E_USER_WARNING);
					}
				}

				if ($del)
				{
					$this->dap_delete_user($user_id, $delposts, $start);

					trigger_error($user->lang['ACP_DAP_USER_DELETED'] . adm_back_link($this->u_action . '&amp;start=' . $start));
				}
			}
			else
			{
				$box_template = ($del) ? 'acp_dap_delete.html' : 'confirm_body.html';

				$s_hidden_fields = build_hidden_fields(array(
					'start'		=> $start,
					'deltime'	=> $deletetime,
					'delmarked'	=> $deletemark,
					'delall'	=> $deleteall,
					'deldays'	=> $deletedays,
					'mark'		=> $marked,
					'st'		=> $sort_days,
					'sk'		=> $sort_key,
					'sd'		=> $sort_dir,
					'action'	=> $action)
				);

				confirm_box(false, $user->lang['CONFIRM_OPERATION'], $s_hidden_fields, $box_template);
			}
		}

		// Sorting
		$limit_days = array(0 => $user->lang['ALL_ENTRIES'], 1 => $user->lang['1_DAY'], 7 => $user->lang['7_DAYS'], 14 => $user->lang['2_WEEKS'], 30 => $user->lang['1_MONTH'], 90 => $user->lang['3_MONTHS'], 180 => $user->lang['6_MONTHS'], 365 => $user->lang['1_YEAR']);
		$sort_by_text = array('u' => $user->lang['SORT_USERNAME'], 't' => $user->lang['SORT_DATE'], 'i' => $user->lang['SORT_IP'], 'o' => $user->lang['SORT_ACTION']);
		$sort_by_sql = array('u' => 'u.username_clean', 't' => 'l.log_time', 'i' => 'l.log_ip', 'o' => 'l.log_operation');

		$s_limit_days = $s_sort_key = $s_sort_dir = $u_sort_param = '';
		gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);

		// Define where and sort sql for use in displaying logs
		$sql_where = ($sort_days) ? (time() - ($sort_days * 86400)) : 0;
		$sql_sort = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

		$keywords = utf8_normalize_nfc(request_var('keywords', '', true));
		$keywords_param = !empty($keywords) ? '&amp;keywords=' . urlencode(htmlspecialchars_decode($keywords)) : '';

		$log_data = array();
		$log_count = 0;
		$start = view_log('dap', $log_data, $log_count, $config['topics_per_page'], $start, 0, 0, 0, $sql_where, $sql_sort, $keywords);

		$template->assign_vars(array(
			'U_ACTION'		=> $this->u_action . "&amp;$u_sort_param$keywords_param&amp;start=$start",

			'S_ON_PAGE'		=> on_page($log_count, $config['topics_per_page'], $start),
			'PAGINATION'	=> generate_pagination($this->u_action . "&amp;$u_sort_param$keywords_param", $log_count, $config['topics_per_page'], $start, true),

			'S_LIMIT_DAYS'	=> $s_limit_days,
			'S_SORT_KEY'	=> $s_sort_key,
			'S_SORT_DIR'	=> $s_sort_dir,
			'S_CLEARLOGS'	=> $auth->acl_get('a_clearlogs'),
			'S_KEYWORDS'	=> $keywords,
		));

		foreach ($log_data as $row)
		{
			$user_c_delete = '';
			$c_user_id = $row['user_id'];

			preg_match_all("/([\d]+)\|(.*)/", $row['action'], $c_match);
			$cookiedata = isset($c_match[0][0]) ? $c_match[0][0] : '';
			$c_item_id = isset($c_match[1][0]) ? $c_match[1][0] : '';
			$c_item_name = isset($c_match[2][0]) ? $c_match[2][0] : '';

			$c_sql = 'SELECT u.user_banned_cookie, u2.user_id, u2.user_colour
				FROM ' . USERS_TABLE . ' u
				INNER JOIN ' . USERS_TABLE . ' u2 ON u2.user_id = ' . (int) $c_item_id . '
				WHERE u.user_id = ' . (int) $c_user_id;
			$c_result = $db->sql_query($c_sql);
			$c_row = $db->sql_fetchrow($c_result);
			$db->sql_freeresult($c_result);

			$ban_status = $this->ban_status($c_row['user_banned_cookie']);
			$c_id = $c_row['user_id'];

			$user_c_delete = (isset($c_id) && $c_id && $can_delete) ? append_sid("{$phpbb_root_path}adm/index.$phpEx", 'i=dap&amp;mode=dupe_log&amp;del=1&amp;u=' . $c_id . '&amp;start=' . $start, true) : '';
			$user_colour = (isset($c_row['user_colour']) && $c_row['user_colour']) ? ' style="color:#' . $c_row['user_colour'] . '" class="username-coloured"' : '';
			$c_common_name = (isset($c_row['user_id']) && $c_row['user_id'] && !empty($c_item_id) && $auth->acl_get('a_user')) ? '<a href="' . append_sid("{$phpbb_root_path}adm/index.$phpEx", 'i=users&amp;mode=overview&amp;u=' . $c_item_id, true) . '"><span' . $user_colour . '>' . $c_item_name  . '</span></a>' : $c_item_name;

			$template->assign_block_vars('log', array(
				'USERNAME'			=> $row['username_full'],
				'S_BAN_STATUS'			=> $ban_status['status'],

				'IP'				=> $row['ip'],
				'DATE'				=> $user->format_date($row['time']),
				'ACTION'			=> str_replace($cookiedata, $c_common_name, $row['action']),
				'ID'				=> $row['id'],

				'U_USER_DELETE'			=> ($can_delete && $row['user_id'] != ANONYMOUS) ? append_sid("{$phpbb_root_path}adm/index.$phpEx", 'i=dap&amp;mode=dupe_log&amp;del=1&amp;u=' . $row['user_id'] . '&amp;start=' . $start, true) : '',
				'U_USER_C_DELETE'		=> $user_c_delete,
				'U_WHOIS'			=> $this->u_action . "&amp;action=whois&amp;user_ip={$row['ip']}",
			));
		}
	}

	function list_dupe_users()
	{
		global $auth, $config, $db, $user, $template, $phpbb_root_path, $phpEx;

		$action		= request_var('action', '');
		$start		= request_var('start', 0);
		$deletetime	= (!empty($_POST['deltime'])) ? true : false;
		$deletemark	= (!empty($_POST['delmarked'])) ? true : false;
		$deleteall	= (!empty($_POST['delall'])) ? true : false;
		$deletedays	= max(0, request_var('deldays', 0));
		$marked		= request_var('mark', array(0));
		$users_per_page = $config['dap_users_per_page'];
		$del		= request_var('del', 0);
		$user_id	= request_var('u', 0);
		$can_delete	= ($config['dap_quick_deletion'] && $auth->acl_get('a_userdel')) ? true : false;
		$delposts	= request_var('delposts', '');

		// Delete entries if requested and able
		if (($del && $can_delete) || (($deletetime || $deletemark || $deleteall) && $auth->acl_get('a_cleardupe')))
		{
			if (confirm_box(true))
			{
				$where_sql = '';

				if ($deletedays)
				{
					$unitime = time() - ($deletedays * 86400);
					$where_sql = ' WHERE user_regdate < ' . $unitime;
				}

				if ($deletemark && sizeof($marked))
				{
					$sql_in = array();
					foreach ($marked as $mark)
					{
						$sql_in[] = $mark;
					}
					$where_sql = ' WHERE ' . $db->sql_in_set('user_id', $sql_in);
					unset($sql_in);
				}

				if ($where_sql || $deleteall)
				{
					$sql = 'UPDATE ' . USERS_TABLE . "
						SET user_double = 0
						$where_sql";
					$db->sql_query($sql);

					$affected_rows = $db->sql_affectedrows();

					if ($affected_rows)
					{
						add_log('admin', 'LOG_CLEAR_DUPE_LIST');
					}
					else
					{
						trigger_error($user->lang['ACP_DAP_NO_MATCHES'] . adm_back_link($this->u_action . '&amp;start=' . $start), E_USER_WARNING);
					}
				}

				if ($del)
				{
					$this->dap_delete_user($user_id, $delposts, $start);

					trigger_error($user->lang['ACP_DAP_USER_DELETED'] . adm_back_link($this->u_action . '&amp;start=' . $start));
				}
			}
			else
			{
				$box_template = ($del) ? 'acp_dap_delete.html' : 'confirm_body.html';

				$s_hidden_fields = build_hidden_fields(array(
					'start'		=> $start,
					'deltime'	=> $deletetime,
					'delmarked'	=> $deletemark,
					'delall'	=> $deleteall,
					'deldays'	=> $deletedays,
					'mark'		=> $marked,
					'action'	=> $action)
				);

				confirm_box(false, $user->lang['CONFIRM_OPERATION'], $s_hidden_fields, $box_template);
			}
		}

		// Get usercount for pagination
		$sql = 'SELECT COUNT(user_id) AS total_users
			FROM ' . USERS_TABLE . '
			WHERE user_double = ' . (bool) true;
		$result = $db->sql_query($sql);
		$total_users = (int) $db->sql_fetchfield('total_users');
		$db->sql_freeresult($result);

		if ($start >= $total_users)
		{
			$start = ($start - $users_per_page < 0) ? 0 : $start - $users_per_page;
		}

		// Get list of users
		$sql = 'SELECT user_id, username, user_ip, user_regdate, user_colour, user_banned_cookie, ip_common_names, c_common_names
			FROM ' . USERS_TABLE . '
			WHERE user_double = ' . (bool) true . '
			ORDER BY user_id DESC';
		$result = $db->sql_query_limit($sql, $users_per_page, $start);

		while ($row = $db->sql_fetchrow($result))
		{
			$ban_status = $this->ban_status($row['user_banned_cookie']);

			$ip_common_names = $c_common_names = $user_c_delete = '';

			if (!empty($row['ip_common_names']))
			{
				$ip_common_set = explode('|', $row['ip_common_names']);
				$ip_ids_set = (isset($ip_common_set[0])) ? explode(',', $ip_common_set[0]) : '';
				$ip_names_set = (isset($ip_common_set[1])) ? explode(',', $ip_common_set[1]) : '';

				if (!empty($ip_ids_set) && !empty($ip_names_set))
				{
					$ip_sql = 'SELECT user_id
						FROM ' . USERS_TABLE . '
						WHERE ' . $db->sql_in_set('user_id', $ip_ids_set);
					$ip_result = $db->sql_query($ip_sql);

					while ($ip_row = $db->sql_fetchrow($ip_result))
					{
						$ip_check_set[] = $ip_row['user_id'];
					}
					$db->sql_freeresult($ip_result);

					foreach ($ip_ids_set as $ip_id)
					{
						$ip_result_set[] = (!empty($ip_check_set) && in_array($ip_id, $ip_check_set)) ? $ip_id : 0;
					}
					unset($ip_check_set);

					for ($i = 0; $i < sizeof($ip_names_set); $i++)
					{
						$ip_names_array[] = ($ip_result_set[$i] && $auth->acl_get('a_user')) ? '<a href="' . append_sid("{$phpbb_root_path}adm/index.$phpEx", 'i=users&amp;mode=overview&amp;u=' . $ip_result_set[$i], true) . '">' . base64_decode($ip_names_set[$i]) . '</a>' : base64_decode($ip_names_set[$i]);
					}
					unset($ip_result_set);

					sort($ip_names_array);
					$ip_common_names = implode(', ', $ip_names_array);
					unset($ip_names_array);
				}
			}

			if (!empty($row['c_common_names']))
			{
				$c_item = explode('|', $row['c_common_names']);
				$c_item[0] = (isset($c_item[0])) ? $c_item[0] : '';
				$c_item[1] = (isset($c_item[1])) ? base64_decode($c_item[1]) : '';

				if (!empty($c_item[0]))
				{
					$c_sql = 'SELECT user_id
						FROM ' . USERS_TABLE . '
						WHERE user_id = ' . (int) $c_item[0];
					$c_result = $db->sql_query($c_sql);
					$c_id = $db->sql_fetchfield('user_id');
					$db->sql_freeresult($c_result);
				}

				$c_common_names = (isset($c_id) && $c_id && !empty($c_item[0]) && $auth->acl_get('a_user')) ? '<a href="' . append_sid("{$phpbb_root_path}adm/index.$phpEx", 'i=users&amp;mode=overview&amp;u=' . $c_item[0], true) . '">' . $c_item[1]  . '</a>' : $c_item[1];
				$user_c_delete = (isset($c_id) && $c_id && $can_delete) ? append_sid("{$phpbb_root_path}adm/index.$phpEx", 'i=dap&amp;mode=dupe_user_list&amp;del=1&amp;u=' . $c_id . '&amp;start=' . $start, true) : '';
			}

			$user_colour = (isset($row['user_colour']) && $row['user_colour']) ? ' style="color:#' . $row['user_colour'] . '" class="username-coloured"' : '';

			$template->assign_block_vars('dupe_users', array(
				'USERNAME'		=> ($auth->acl_get('a_user')) ? '<a href="' . append_sid("{$phpbb_root_path}adm/index.$phpEx", 'i=users&amp;mode=overview&amp;u=' . $row['user_id'], true) . '"><span' . $user_colour . '>' . $row['username']  . '</span></a>' : $row['username'],
				'USER_IP'			=> $row['user_ip'],
				'DATE'				=> $user->format_date($row['user_regdate']),
				'ID'				=> $row['user_id'],
				'IP_COMMON_NAMES'		=> $ip_common_names,
				'COOKIE_COMMON_NAMES'		=> $c_common_names,
				'S_BAN_STATUS'			=> $ban_status['status'],

				'U_USER_COOKIE_BAN'		=> append_sid("{$phpbb_root_path}adm/index.$phpEx", 'i=dap&amp;mode=dupe_user_list&amp;ban=1&amp;u=' . $row['user_id'] . '&amp;start=' . $start, true),
				'U_USER_COOKIE_WHITELIST'	=> append_sid("{$phpbb_root_path}adm/index.$phpEx", 'i=dap&amp;mode=dupe_user_list&amp;ban=2&amp;u=' . $row['user_id'] . '&amp;start=' . $start, true),
				'U_USER_COOKIE_EXCLUSION'	=> append_sid("{$phpbb_root_path}adm/index.$phpEx", 'i=dap&amp;mode=dupe_user_list&amp;ban=3&amp;u=' . $row['user_id'] . '&amp;start=' . $start, true),
				'U_USER_COOKIE_UNBLOCK'		=> append_sid("{$phpbb_root_path}adm/index.$phpEx", 'i=dap&amp;mode=dupe_user_list&amp;ban=0&amp;u=' . $row['user_id'] . '&amp;start=' . $start, true),
				'U_USER_DELETE'			=> ($can_delete) ? append_sid("{$phpbb_root_path}adm/index.$phpEx", 'i=dap&amp;mode=dupe_user_list&amp;del=1&amp;u=' . $row['user_id'] . '&amp;start=' . $start, true) : '',
				'U_USER_C_DELETE'		=> $user_c_delete,
				'U_WHOIS'			=> $this->u_action . "&amp;action=whois&amp;user_ip={$row['user_ip']}",
			));
		}
		$db->sql_freeresult($result);

		$template->assign_vars(array(			
			'U_ACTION'		=> $this->u_action . "&amp;start=$start",

			'PAGINATION'		=> generate_pagination($this->u_action, $total_users, $users_per_page, $start, true),	
			'S_ON_PAGE'			=> on_page($total_users, $users_per_page, $start),
			'S_CLEAR_DUPE_LIST'	=> (!empty($total_users) && $auth->acl_get('a_cleardupe')) ? true : false,
		));

		return;
	}

	function page_output($display_vars, $form_key)
	{
		global $config, $db, $user, $template, $phpbb_root_path, $phpEx;

		$submit 		= (isset($_POST['submit'])) ? true : false;
		$exclusubmit		= (isset($_POST['exclusubmit'])) ? true : false;
		$unexclusubmit		= (isset($_POST['unexclusubmit'])) ? true : false;

		$this->new_config = $config;
		$cfg_array = (isset($_REQUEST['config'])) ? utf8_normalize_nfc(request_var('config', array('' => ''), true)) : $this->new_config;
		$cfg_array['dap_post_forum_id'] = implode(',', request_var('dap_post_forum_id', array(0)));
		$error = array();

		// We validate the complete config if whished
		validate_config_vars($display_vars['vars'], $cfg_array, $error);

		if (($submit || $exclusubmit || $unexclusubmit) && !check_form_key($form_key))
		{
			$error[] = $user->lang['FORM_INVALID'];
		}

		if ($submit)
		{
			if (strlen($cfg_array['dap_post_forum_id']) > 255)
			{
				$error[] = $user->lang['ACP_DAP_FORUM_ID_ERROR'];
			}

			if (!empty($cfg_array['dap_post_forum_id']) || $cfg_array['dap_pm_notification'])
			{
				$sql = 'SELECT user_id
					FROM ' . USERS_TABLE . '
					WHERE user_id = ' . (int) $cfg_array['dap_alert_user_id'];
				$result = $db->sql_query($sql);
				$alert_id = $db->sql_fetchfield('user_id');
				$db->sql_freeresult($result);

				if ($alert_id < 2)
				{
					$error[] = $user->lang['ACP_DAP_USER_ID_ERROR'];
				}
			}
		}

		// Do not write values if there is an error
		if (sizeof($error))
		{
			$submit = false;
		}

		if ($submit)
		{
			// We go through the display_vars to make sure no one is trying to set variables he/she is not allowed to...
			foreach ($display_vars['vars'] as $config_name => $null)
			{
				if (!isset($cfg_array[$config_name]) || strpos($config_name, 'legend') !== false)
				{
					continue;
				}

				$this->new_config[$config_name] = $config_value = $cfg_array[$config_name];

				set_config($config_name, $config_value);
			}

			add_log('admin', 'ACP_DAP_SETTINGS_UPDATED');
			trigger_error($user->lang['ACP_DAP_SAVED_SETTINGS'] . adm_back_link($this->u_action));
		}

		$exclusion 			= request_var('exclusion', '');
		$excludes 			= request_var('excludes', '');
		$exclusion_options	= request_var('exclusion_options', '');

		$sql = 'SELECT u.user_id, u.username, u2.user_id AS excluded_user_id, u2.username AS excluded_username
			FROM ' . USERS_TABLE . ' u INNER JOIN ' . DAP_LOG_EXCLUDES_TABLE . ' e ON u.user_id = e.user_id
				INNER JOIN ' . USERS_TABLE . ' u2 ON e.exclude_id = u2.user_id
			ORDER BY u.username_clean, u2.username_clean ASC';
		$result = $db->sql_query($sql);

		$existed = array();
		while ($row = $db->sql_fetchrow($result))
		{
			$existed[] = $row['user_id'] . ':' . $row['excluded_user_id'];
			$existed[] = $row['excluded_user_id'] . ':' . $row['user_id'];
			$exclusion_options .= '<option value="' . $row['user_id'] . ':' . $row['excluded_user_id'] . '">' . $row['username'] . ' &#8212; ' . $row['excluded_username'] . '</option>';
		}
		$db->sql_freeresult($result);

		if ($exclusubmit)
		{
			if (!empty($exclusion) && !empty($excludes))
			{
				$exclusion_list = array_map('trim', explode("\n", utf8_normalize_nfc(request_var('exclusion', '', true))));
				$excludes_list = array_map('trim', explode("\n", utf8_normalize_nfc(request_var('excludes', '', true))));

				$sql_usernames = $exclusion_id_ary = array();

				foreach ($exclusion_list as $username)
				{
					$username = trim($username);
					if ($username != '')
					{
						$sql_usernames[] = utf8_clean_string($username);
					}
				}

				$sql = 'SELECT user_id
					FROM ' . USERS_TABLE . '
					WHERE ' . $db->sql_in_set('username_clean', $sql_usernames);
				$result = $db->sql_query($sql);

				unset($sql_usernames);

				if ($row = $db->sql_fetchrow($result))
				{
					do
					{
						$exclusion_id_ary[] = (int) $row['user_id'];
					}
					while ($row = $db->sql_fetchrow($result));
				}
				else
				{
					$db->sql_freeresult($result);
					trigger_error($user->lang['NO_USERS'] . adm_back_link($this->u_action), E_USER_WARNING);
				}
				$db->sql_freeresult($result);

				if (sizeof($exclusion_id_ary))
				{
					$sql_exclude_names = $exclude_id_ary = array();

					foreach ($excludes_list as $username)
					{
						$username = trim($username);
						if ($username != '')
						{
							$sql_exclude_names[] = utf8_clean_string($username);
						}
					}

					$e_sql = 'SELECT user_id
						FROM ' . USERS_TABLE . '
						WHERE ' . $db->sql_in_set('username_clean', $sql_exclude_names);
					$e_result = $db->sql_query($e_sql);

					unset($sql_exclude_names);

					if ($e_row = $db->sql_fetchrow($e_result))
					{
						do
						{
							$exclude_id_ary[] = (int) $e_row['user_id'];
						}
						while ($e_row = $db->sql_fetchrow($e_result));
					}
					else
					{
						$db->sql_freeresult($e_result);
						trigger_error($user->lang['NO_USERS'] . adm_back_link($this->u_action), E_USER_WARNING);
					}
					$db->sql_freeresult($e_result);

					if (sizeof($exclude_id_ary))
					{
						$sql_ary = array();
						foreach ($exclusion_id_ary as $exclusion_id)
						{
							foreach ($exclude_id_ary as $exclude_id)
							{
								if ($exclusion_id != $exclude_id && !in_array($exclusion_id . ':' . $exclude_id, $existed))
								{
									$existed[] = $exclusion_id . ':' . $exclude_id;
									$existed[] = $exclude_id . ':' . $exclusion_id;

									$sql_ary[] = array(
										'user_id'		=> (int) $exclusion_id,
										'exclude_id'		=> (int) $exclude_id,
									);
								}
							}
						}
						$db->sql_multi_insert(DAP_LOG_EXCLUDES_TABLE, $sql_ary);

						unset($exclude_id_ary, $sql_ary);
					}

					unset($exclusion_id_ary);
				}

				add_log('admin', 'LOG_EXCLUDES_UPDATED');
				trigger_error($user->lang['DAP_EXCLUDES_UPDATE_SUCCESSFUL'] . adm_back_link($this->u_action));
			}
			else
			{
				trigger_error($user->lang['NO_USER_SPECIFIED'] . adm_back_link($this->u_action), E_USER_WARNING);
			}
		}
		else if ($unexclusubmit)
		{
			$unexclusion = request_var('unexclusion', array(''));

			if (sizeof($unexclusion))
			{
				foreach ($unexclusion as $id_item)
				{
					$id_ary = explode(':', $id_item);

					$sql = 'DELETE FROM ' . DAP_LOG_EXCLUDES_TABLE . '
						WHERE user_id = ' . (int) $id_ary[0] . '
							AND exclude_id = ' . (int) $id_ary[1];
					$db->sql_query($sql);
				}

				add_log('admin', 'LOG_EXCLUDES_UPDATED');
				trigger_error($user->lang['DAP_EXCLUDES_UPDATE_SUCCESSFUL'] . adm_back_link($this->u_action));
			}
			else
			{
				trigger_error($user->lang['ACP_DAP_NO_USERS_SELECTED'] . adm_back_link($this->u_action), E_USER_WARNING);
			}
		}

		unset($existed);

		$template->assign_vars(array(
			'DAP_MOD_VERSION'		=> sprintf($user->lang['ACP_DAP_SETTINGS_EXPLAIN'], $config['dap_version']),
			'EXCLUSION_OPTIONS'		=> $exclusion_options,
			'ERROR_MSG'			=> implode('<br />', $error),
			'L_TITLE'			=> $user->lang[$display_vars['title']],
			'L_TITLE_EXPLAIN'	=> $user->lang[$display_vars['title'] . '_EXPLAIN'],
			'S_EXCLUSION_OPTIONS'	=> ($exclusion_options) ? true : false,
			'S_ERROR'			=> (sizeof($error)) ? true : false,

			'U_ACTION'			=> $this->u_action,
			'U_FIND_USERNAME'		=> append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=searchuser&amp;form=acp_lc&amp;field=exclusion'),
			'U_FIND_EXCLUDES'		=> append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=searchuser&amp;form=acp_lc&amp;field=excludes'),
		));

		// Output relevant page
		foreach ($display_vars['vars'] as $config_key => $vars)
		{
			if (!is_array($vars) && strpos($config_key, 'legend') === false)
			{
				continue;
			}

			if (strpos($config_key, 'legend') !== false)
			{
				$template->assign_block_vars('options', array(
					'S_LEGEND'		=> true,
					'LEGEND'		=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
				);

				continue;
			}

			$type = explode(':', $vars['type']);

			$l_explain = '';
			if ($vars['explain'] && isset($vars['lang_explain']))
			{
				$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
			}
			else if ($vars['explain'])
			{
				$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
			}

			$content = build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars);

			if (empty($content))
			{
				continue;
			}

			$template->assign_block_vars('options', array(
					'KEY'			=> $config_key,
					'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
					'S_EXPLAIN'		=> $vars['explain'],
					'TITLE_EXPLAIN'	=> $l_explain,
					'CONTENT'		=> $content,
				)
			);

			unset($display_vars['vars'][$config_key]);
		}
	}
}

?>