<?php

/**
*
* @package Double Account Preventer
* @copyright (c) 2009 kmklr72 with IP check code by mtrs and mail codes by ameeck's notify admin registration mod, 2013 www.phpbb-work.ru
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class dap
{
	// Check for the DAP cookie
	function cookie_check()
	{
		global $config, $db;

		$double_account = array();

		if (isset($_COOKIE[$config['cookie_name'] . '_ck']))
		{
			$cookiedata = request_var($config['cookie_name'] . '_ck', '', true, true);
			$user_inactive = '';

			if ($config['dap_ignore_inactive'])
			{
				$c_userdata = (!empty($cookiedata)) ? explode('|', $cookiedata) : '';
				$cookie_id = isset($c_userdata[0]) ? $c_userdata[0] : '';

				$sql = 'SELECT user_id FROM ' . USERS_TABLE . '
					WHERE user_id = ' . (int) $cookie_id . '
						AND user_type = ' . USER_INACTIVE;
				$result = $db->sql_query($sql);
				$user_inactive = $db->sql_fetchfield('user_id');
				$db->sql_freeresult($result);
			}

			if (empty($user_inactive))
			{
				$double_account = array(
					'user_double'			=> true,
					'c_common_names'		=> $cookiedata,
				);
			}
		}

		return $double_account;
	}

	// Ban user by cookie
	function cookie_ban_user($user_id, $ban)
	{
		global $db;

		$and_sql = ($ban) ? 'AND user_type < ' . USER_IGNORE : '';

		$sql = 'UPDATE ' . USERS_TABLE . '
			SET user_banned_cookie = ' . (int) $ban . '
			WHERE user_id = ' . (int) $user_id . "
				$and_sql";
		$db->sql_query($sql);
	}

	// Check for cookie bans and log entries handle
	function cookie_tracking($banned = false, $admin = false)
	{
		global $config, $db, $user;

		$dap_ban = false;

		if (!isset($config['dap_version']))
		{
			return $dap_ban;
		}

		$id = $user->data['user_id'];
		$name = $user->data['username'];

		if ($user->data['user_type'] != USER_FOUNDER)
		{
			$banned_cookie = request_var($config['cookie_name'] . '_bc', '', false, true);
		}

		$user_bc = ($user->data['user_type'] != USER_FOUNDER) ? $user->data['user_banned_cookie'] : 0;

		$cookiedata = request_var($config['cookie_name'] . '_ck', '', true, true);
		$c_userdata = (!empty($cookiedata)) ? explode('|', $cookiedata) : '';
		$cookie_id = isset($c_userdata[0]) ? $c_userdata[0] : '';
		$cookie_name = isset($c_userdata[1]) ? base64_decode($c_userdata[1]) : '';
		$userdata = $cookie_id . '|' . $cookie_name;

		if (!empty($cookie_id))
		{
			$sql = 'SELECT user_id, user_type
				FROM ' . USERS_TABLE . '
				WHERE user_id = ' . (int) $cookie_id;
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);

			if ($config['dap_ignore_inactive'] && isset($row['user_id']))
			{
				$cookie_id = ($row['user_type'] != USER_INACTIVE) ? $cookie_id : $id;
			}
		}

		if (!isset($_COOKIE[$config['cookie_name'] . '_ck']) || !isset($row['user_id']))
		{
			$user->set_cookie('ck', $id . '|' . base64_encode($name), time() + 518400000);
		}

		if ($user->data['user_type'] < USER_IGNORE && $config['dap_cookie_ban'] && $user_bc != 3)
		{
			if (!empty($user_bc) && (!isset($banned_cookie) || $banned_cookie != $user_bc))
			{
				$user->set_cookie('bc', $user_bc, time() + 518400000);
			}

			if ($config['dap_cookie_autoban'] && empty($user_bc) && isset($banned_cookie) && $banned_cookie == 1)
			{
				$this->cookie_ban_user($id, true);
				add_log('mod', 0, 0, 'LOG_COOKIE_AUTOBAN', $name);
				add_log('user', $id, 'LOG_COOKIE_AUTOBAN', $name);
			}

			if ($user_bc == 1 || (isset($banned_cookie) && $banned_cookie == 1 && $user_bc != 2))
			{
				$dap_ban = true;
			}
		}

		$excluded = array();

		$sql = 'SELECT * FROM ' . DAP_LOG_EXCLUDES_TABLE . '
			WHERE user_id = ' . $id . '
				OR exclude_id = ' . $id;
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$excluded[] = $row['user_id'];
			$excluded[] = $row['exclude_id'];
		}
		$db->sql_freeresult($result);

		$excluded = array_unique($excluded);

		if ($config['dap_cookie_check'] && isset($_COOKIE[$config['cookie_name'] . '_ck']) && $id != $cookie_id && !in_array($cookie_id, $excluded))
		{
			if ($config['dap_cookie_ban'] && isset($banned_cookie) && $banned_cookie == 1 && $user_bc < 2)
			{
				add_log('dap', 'LOG_COOKIE_BLOCK', $userdata);
			}
			else if ($config['dap_cookie_ban'] && $user_bc == 1)
			{
				add_log('dap', 'LOG_BLACKLIST_BLOCK', $userdata);
			}
			else if ($banned)
			{
				add_log('dap', 'LOG_STANDARD_BLOCK', $userdata);
			}
			else if ($admin)
			{
				add_log('dap', 'LOG_LOGIN_WITH_DATA_ACP', $userdata);
			}
			else
			{
				add_log('dap', 'LOG_LOGIN_WITH_DATA', $userdata);
			}

			if ($config['dap_user_notes_entry'])
			{
				$found = false;

				$sql = 'SELECT log_data
					FROM ' . LOG_TABLE . '
					WHERE log_type = ' . LOG_USERS . "
						AND user_id = $id
						AND log_operation = 'LOG_USER_NOTE_AUTH'";
				$result = $db->sql_query($sql);

				while ($row = $db->sql_fetchrow($result))
				{
					if (strpos($row['log_data'], $cookie_name) !== false)
					{
						$found = true;
					}
				}

				if (!$found)
				{
					add_log('user', $id, 'LOG_USER_NOTE_AUTH', $cookie_name);
				}
			}
		}

		unset($excluded);

		return $dap_ban;
	}

	// Replace ip-duplicates with real accounts
	function replace_ip_names($ip_common_names, $mail = false)
	{
		global $phpbb_root_path, $phpEx;

		if (!empty($ip_common_names))
		{
			$ip_common_set = explode('|', $ip_common_names);
			$ip_ids_set = (isset($ip_common_set[0])) ? explode(',', $ip_common_set[0]) : '';
			$ip_names_set = (isset($ip_common_set[1])) ? explode(',', $ip_common_set[1]) : '';

			if (!empty($ip_ids_set) && !empty($ip_names_set))
			{
				for ($i = 0; $i < sizeof($ip_ids_set); $i++)
				{
					if ($mail)
					{
						$ip_names_array[] = htmlspecialchars_decode(base64_decode($ip_names_set[$i]));
					}
					else
					{
						$ip_names_array[] = '[url=' . generate_board_url() . '/memberlist.' . $phpEx . '?mode=viewprofile&amp;u=' . $ip_ids_set[$i] . ']' . base64_decode($ip_names_set[$i]) . '[/url]';
					}
				}

				sort($ip_names_array);
				$ip_common_names = implode(', ', $ip_names_array);
				unset($ip_names_array);
			}
		}

		return $ip_common_names;
	}

	// Replace cookie-duplicates with real accounts
	function replace_cookie_names($c_common_names, $mail = false)
	{
		global $db, $phpbb_root_path, $phpEx;

		if (!empty($c_common_names))
		{
			$c_item = explode('|', $c_common_names);
			$c_item[0] = (isset($c_item[0])) ? $c_item[0] : '';
			$c_item[1] = (isset($c_item[1])) ? base64_decode($c_item[1]) : '';

			if (!$mail && !empty($c_item[0]))
			{
				$c_sql = 'SELECT user_id
					FROM ' . USERS_TABLE . '
					WHERE user_id = ' . (int) $c_item[0];
				$c_result = $db->sql_query($c_sql);
				$c_id = $db->sql_fetchfield('user_id');
				$db->sql_freeresult($c_result);
			}

			if ($mail)
			{
				$c_common_names = htmlspecialchars_decode($c_item[1]);
			}
			else
			{
				$c_common_names = (isset($c_id) && $c_id && !empty($c_item[0])) ? '[url=' . generate_board_url() . '/memberlist.' . $phpEx . '?mode=viewprofile&amp;u=' . $c_item[0] . ']' . $c_item[1] . '[/url]' : $c_item[1];
			}
		}

		return $c_common_names;
	}

	// Replace shortcodes for the PMs and posts
	function replace_strings(&$string, $user_id, $data_username, $data_email, $user_regdate, $ip_common_names, $c_common_names)
	{
		global $config, $db, $user, $phpbb_root_path, $phpEx;

		$string = str_replace('[sitename]', $config['sitename'], $string);
		$string = str_replace('[username]', $data_username, $string);
		$string = str_replace('[user_ip]', $user->ip, $string);
		$string = str_replace('[user_email]', $data_email, $string);
		$string = str_replace('[user_regdate]', $user->format_date($user_regdate, false, true), $string);
		$string = str_replace('[ip_common_names]', $ip_common_names, $string);
		$string = str_replace('[c_common_names]', $c_common_names, $string);

		return;
	}

	// Send a PM to all users with a_user permission
	function send_dap_pm($user_id, $data_username, $data_email, $user_regdate, $ip_common_names, $c_common_names)
	{
		global $auth, $config, $db, $user, $phpbb_root_path, $phpEx;

		include($phpbb_root_path . 'includes/functions_privmsgs.' . $phpEx);

		// Grab an array of user_id's with a_user permissions to send a PM to
		$admin_ary = $auth->acl_get_list(false, 'a_user', false);
		$admin_ary = (!empty($admin_ary[0]['a_user'])) ? $admin_ary[0]['a_user'] : array();

		if (sizeof($admin_ary))
		{
			$where_sql = 'WHERE ' . $db->sql_in_set('user_id', $admin_ary);
		}
		else
		{
			$where_sql = 'WHERE user_type = ' . USER_FOUNDER; // There are no admins, so select a founder
		}

		$sql = 'SELECT user_id, username, user_email, user_lang, user_jabber, user_notify_type
			FROM ' . USERS_TABLE . ' ' .
			$where_sql;
		$result = $db->sql_query($sql);

		// Loop through our results
		while ($row = $db->sql_fetchrow($result))
		{
			$contact_users[] = $row;
		}
		$db->sql_freeresult($result);

		// Get the subject and message
		$message = $user->lang['DAP_NOTIFICATION_MESSAGE'];
		$subject = $user->lang['DAP_NOTIFICATION_SUBJECT'];

		$username_full = '[url=' . generate_board_url() . '/memberlist.' . $phpEx . '?mode=viewprofile&amp;u=' . $user_id . ']' . $data_username . '[/url]';

		// Replace the shortcodes
		$this->replace_strings($message, $user_id, $username_full, $data_email, $user_regdate, $ip_common_names, $c_common_names);
		$this->replace_strings($subject, $user_id, $data_username, $data_email, $user_regdate, $ip_common_names, $c_common_names);

		$sql = 'SELECT username, user_ip
			FROM ' . USERS_TABLE . '
			WHERE user_id = ' . (int) $config['dap_alert_user_id'];
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$alert_user_ip = $row['user_ip'];
			$alert_username = $row['username'];
		}
		$db->sql_freeresult($result);

		$uid = $bitfield = $options = ''; 

		generate_text_for_storage($subject, $uid, $bitfield, $options, false, false, false);
		generate_text_for_storage($message, $uid, $bitfield, $options, true, true, true);

		// Set the PM data
		$pm_data = array(
			'from_user_id'		=> $config['dap_alert_user_id'],
			'from_user_ip'		=> $alert_user_ip,
			'from_username'		=> $alert_username,
			'enable_sig'		=> false,
			'enable_bbcode'		=> true,
			'enable_smilies'	=> true,
			'enable_urls'		=> false,
			'icon_id'			=> 0,
			'bbcode_bitfield'	=> $bitfield,
			'bbcode_uid'		=> $uid,
			'message'			=> $message,
		);

		// Loop through our list of users
		for ($i = 0, $size = sizeof($contact_users); $i < $size; $i++)
		{
			$pm_data['address_list'] = array('u' => array($contact_users[$i]['user_id'] => 'to'));

			submit_pm('post', $subject, $pm_data, true);

			unset($contact_users[$i]);
		}
	}

	// Post in the specified forums
	function submit_dap_post($user_id, $data_username, $data_email, $user_regdate, $ip_common_names, $c_common_names)
	{
		global $auth, $config, $db, $user, $phpbb_root_path, $phpEx;

		include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);

		// Get the subject and message
		// Also get the forums to post in
		$message = $user->lang['DAP_NOTIFICATION_MESSAGE'];
		$subject = $user->lang['DAP_NOTIFICATION_SUBJECT'];
		$forums = $config['dap_post_forum_id'];
		$alert_user_id = $config['dap_alert_user_id'];

		$username_full = '[url=' . generate_board_url() . '/memberlist.' . $phpEx . '?mode=viewprofile&amp;u=' . $user_id . ']' . $data_username . '[/url]';

		// Replace the shortcodes
		$this->replace_strings($message, $user_id, $username_full, $data_email, $user_regdate, $ip_common_names, $c_common_names);
		$this->replace_strings($subject, $user_id, $data_username, $data_email, $user_regdate, $ip_common_names, $c_common_names);

		// Backup and replace the $user and $auth constants so an actual user can post, not just a guest with a username
		$backup = array(
			'user_data'	=> $user->data,
			'user_ip'	=> $user->ip,
			'auth'		=> $auth,
		);

		$sql = "SELECT *
			FROM " . USERS_TABLE . "
			WHERE user_id = '" . $alert_user_id . "'";
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			// We have to overwrite some $user values to make the script post correctly
			$user->data = $row;
			$user->ip = '0.0.0.0';
			$auth->acl($user->data);
			$user->data['is_registered'] = false;

			// We set these so we don't have to use the overwritten values. It's just safer this way.
			$alert_user = array(
				'user_id'		=> (int) $alert_user_id,
				'user_ip'		=> '0.0.0.0',
				'username'		=> $row['username'],
			);
		}
		$db->sql_freeresult($result);

		$forums = explode(',', $forums);

		// variables to hold the parameters for submit_post
		$poll = $uid = $bitfield = $options = ''; 

		generate_text_for_storage($subject, $uid, $bitfield, $options);
		generate_text_for_storage($message, $uid, $bitfield, $options, true, true, true);

		// Set the post data
		$data = array( 
			'icon_id'			=> false,
			'enable_bbcode'		=> true,
			'enable_smilies'	=> true,
			'enable_urls'		=> true,
			'enable_sig'		=> true,
			'message'			=> $message,
			'message_md5'		=> md5($message),
			'bbcode_bitfield'	=> $bitfield,
			'bbcode_uid'		=> $uid,
			'post_edit_locked'	=> 0,
			'topic_title'		=> $subject,
			'notify_set'		=> false,
			'notify'			=> false,
			'post_time' 		=> 0,
			'forum_name'		=> '',
			'enable_indexing'	=> true,
			'topic_approved'	=> true,
			'post_approved'		=> true,
		);

		// Loop through and post in the correct forums
		foreach ($forums as $forum_id)
		{
			$data['forum_id'] = $forum_id;

			// Time to post
			submit_post('post', $subject, $alert_user['username'], POST_NORMAL, $poll, $data);
		}

		// Extract the backup to set the $user and $auth constants to what they were before
		$auth = $backup['auth'];
		$user->data = $backup['user_data'];
		$user->ip = $backup['user_ip'];
		unset($backup);
	}

	// Send email to all users with a_user permission
	function notify_admin_dupe_ips($data_username, $data_email, $user_regdate, $ip_common_names, $c_common_names)
	{
		global $config, $db, $auth, $user, $phpbb_root_path, $phpEx;

		include_once($phpbb_root_path . 'includes/functions_messenger.' . $phpEx);

		$messenger = new messenger(false);

		// Codes below take from "Notify admin on registration MOD" by ameeck
		// Grab an array of user_id's with a_user permissions ... these users can activate a user
		$admin_ary = $auth->acl_get_list(false, 'a_user', false);
		$admin_ary = (!empty($admin_ary[0]['a_user'])) ? $admin_ary[0]['a_user'] : array();

		if (sizeof($admin_ary))
		{
			$where_sql = 'WHERE ' . $db->sql_in_set('user_id', $admin_ary);
		}
		else
		{
			$where_sql = 'WHERE user_type = ' . USER_FOUNDER; // There are no admins, so select a founder
		}

		$sql = 'SELECT user_id, username, user_email, user_lang, user_jabber, user_notify_type
			FROM ' . USERS_TABLE . ' ' .
			$where_sql;
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$messenger->template('admin_notify_duplicates', $row['user_lang']);
			$messenger->to($row['user_email'], $row['username']);
			$messenger->im($row['user_jabber'], $row['username']);

			// Email headers
			$messenger->anti_abuse_headers($config, $user);

			$messenger->assign_vars(array(
				'USERNAME'				=> htmlspecialchars_decode($data_username),
				'USER_MAIL'				=> $data_email,
				'USER_IP'				=> $user->ip,
				'USER_REGDATE'			=> $user->format_date($user_regdate, false, true),
				'IP_COMMON_NAMES'		=> $this->replace_ip_names($ip_common_names, true),
				'COOKIE_COMMON_NAMES'	=> $this->replace_cookie_names($c_common_names, true),
			));

			$messenger->send($row['user_notify_type']);
		}
		$db->sql_freeresult($result);
	}

	/*
	* The following Duplicate IP check code was created by mtrs and ameeck
	* Huge thanks to both of them for allowing me to use their code for this mod
	*/
	function duplicate_ip_check()
	{
		global $config, $db, $user;

		$double_account = array();

		if ($config['dap_ip_check'] == IP_CHECK_FULL)
		{
			$sql_add = ' UNION ALL SELECT user_id AS total_id
				FROM ' . LOG_TABLE . '
				WHERE log_ip = "' . $db->sql_escape($user->ip) . '"
					AND user_id <> ' . ANONYMOUS . '
					UNION ALL
				SELECT poster_id AS total_id
				FROM ' . POSTS_TABLE . '
				WHERE poster_ip = "' . $db->sql_escape($user->ip) . '"
					AND poster_id <> ' . ANONYMOUS . '
					UNION ALL
				SELECT author_id AS total_id
				FROM ' . PRIVMSGS_TABLE . '
				WHERE author_ip = "' . $db->sql_escape($user->ip) . '"
					AND author_id <> ' . ANONYMOUS . '
					UNION ALL
				SELECT vote_user_id AS total_id
				FROM ' . POLL_VOTES_TABLE . '
				WHERE vote_user_ip = "' . $db->sql_escape($user->ip) . '"
					AND vote_user_id <> ' . ANONYMOUS;
		}
		else
		{
			$sql_add = '';
		}

		if ($config['dap_ip_check'] >= IP_CHECK_LIGHT)
		{
			$sql = 'SELECT user_id AS total_id
				FROM ' . USERS_TABLE . '
				WHERE user_ip = "' . $db->sql_escape($user->ip) . '"
					AND user_type <> ' . USER_IGNORE . '
					UNION ALL
				SELECT session_user_id AS total_id
				FROM ' . SESSIONS_TABLE . '
				WHERE session_ip = "' . $db->sql_escape($user->ip) . '"
					AND session_user_id <> ' . ANONYMOUS . '
					UNION ALL
				SELECT user_id AS total_id
				FROM ' . SESSIONS_KEYS_TABLE . '
				WHERE last_ip = "' . $db->sql_escape($user->ip) . '"
					AND user_id <> ' . ANONYMOUS . $sql_add;
			$result = $db->sql_query($sql);

			while ($row = $db->sql_fetchrow($result))
			{
				$dupe_ips[] = $row['total_id'];
			}
			$db->sql_freeresult($result);
		}

		if (isset($dupe_ips))
		{
			$dupe_ips = array_unique($dupe_ips);

			if ($config['dap_ignore_inactive'])
			{
				$ignore_ips = array();

				$sql = 'SELECT user_id, user_type
					FROM ' . USERS_TABLE . '
					WHERE ' . $db->sql_in_set('user_id', $dupe_ips);
				$result = $db->sql_query($sql);

				while ($row = $db->sql_fetchrow($result))
				{
					$ignore_ips[] = ($row['user_type'] == USER_INACTIVE) ? $row['user_id'] : 0;
				}
				$db->sql_freeresult($result);

				$dupe_ips = array_diff($dupe_ips, $ignore_ips);

				unset($ignore_ips);
			}

			if (sizeof($dupe_ips))
			{
				// Get usernames list for notifications
				$sql = 'SELECT user_id, username
					FROM ' . USERS_TABLE . '
					WHERE ' . $db->sql_in_set('user_id', $dupe_ips);
				$result = $db->sql_query($sql);

				while ($row = $db->sql_fetchrow($result))
				{
					$ip_common_ids_array[] = $row['user_id'];
					$ip_common_names_array[] = base64_encode($row['username']);
				}
				$db->sql_freeresult($result);

				// Generate list of duplicate accounts
				$ip_common_ids = (isset($ip_common_ids_array)) ? implode(',', $ip_common_ids_array) : '';
				$ip_common_names = (isset($ip_common_names_array)) ? implode(',', $ip_common_names_array) : '';

				unset($dupe_ips, $ip_common_ids_array, $ip_common_names_array);

				// Assign array values for insertion into the users table
				$double_account = array(
					'user_double'			=> true,
					'ip_common_names'	=> $ip_common_ids . '|' . $ip_common_names,
				);
			}
		}

		return $double_account;
	}

	/*
	* Hook for registration process...
	*/
	function user_register($user_row, $cp_data)
	{
		global $config, $user;

		$banned_cookie = request_var($config['cookie_name'] . '_bc', '', false, true);

		if ($config['dap_cookie_ban'] && $config['dap_cookie_reg_deny'] && isset($banned_cookie) && $banned_cookie == 1)
		{
			$deny_text = ($config['dap_reg_deny_message']) ? $config['dap_reg_deny_message'] : $user->lang['DAP_COOKIE_DENY_REGISTER_TEXT'];
			$message = '<em>' . $deny_text . '</em><br /><br />' . sprintf($user->lang['DAP_CONTACT_ADMIN_MESSAGE'], '', '<a href="mailto:' . $config['board_contact'] . '">', '</a>');
			trigger_error($message);
		}

		$user_row['ip_common_names'] = $user_row['c_common_names'] = '';

		if ($config['dap_cookie_check'])
		{
			$c_double_account = $this->cookie_check();

			if (sizeof($c_double_account))
			{
				$user_row = array_merge($user_row, $c_double_account);
			}
		}

		if ($config['dap_ip_check'] >= IP_CHECK_LIGHT)
		{
			$ip_double_account = $this->duplicate_ip_check();

			if (sizeof($ip_double_account))
			{
				$user_row = array_merge($user_row, $ip_double_account);
			}
		}

		// Register user...
		$user_id = user_add($user_row, $cp_data);

		// Set user_id for log entries
		$user->data['user_id'] = $user_id;

		if (!isset($_COOKIE[$config['cookie_name'] . '_ck']))
		{
			$user->set_cookie('ck', $user_id . '|' . base64_encode($user_row['username']), time() + 518400000);
		}

		if ((isset($c_double_account) && sizeof($c_double_account)) || (isset($ip_double_account) && sizeof($ip_double_account)))
		{
			$ip_common_names = $this->replace_ip_names($user_row['ip_common_names']);
			$c_common_names = $this->replace_cookie_names($user_row['c_common_names']);

			if ($config['dap_email_notification'])
			{
				$this->notify_admin_dupe_ips($user_row['username'], $user_row['user_email'], $user_row['user_regdate'], $user_row['ip_common_names'], $user_row['c_common_names']);
			}

			if ($config['dap_pm_notification'])
			{
				$this->send_dap_pm($user_id, $user_row['username'], $user_row['user_email'], $user_row['user_regdate'], $ip_common_names, $c_common_names);
			}

			if ($config['dap_user_notes_entry'])
			{
				if (!empty($user_row['ip_common_names']))
				{
					add_log('user', $user_id, 'LOG_USER_NOTE_IP', $this->replace_ip_names($user_row['ip_common_names'], true));
				}

				if (!empty($user_row['c_common_names']))
				{
					add_log('user', $user_id, 'LOG_USER_NOTE_COOKIE', $this->replace_cookie_names($user_row['c_common_names'], true));
				}
			}

			if (!empty($config['dap_post_forum_id']))
			{
				$this->submit_dap_post($user_id, $user_row['username'], $user_row['user_email'], $user_row['user_regdate'], $ip_common_names, $c_common_names);
			}
		}

		if ($config['dap_cookie_ban'] && $config['dap_cookie_autoban'] && isset($banned_cookie) && $banned_cookie == 1)
		{
			$this->cookie_ban_user($user_id, true);

			add_log('mod', 0, 0, 'LOG_COOKIE_AUTOBAN', $user_row['username']);
			add_log('user', $user_id, 'LOG_COOKIE_AUTOBAN', $user_row['username']);
		}

		$user->data['user_id'] = ANONYMOUS;

		return $user_id;
	}
}

?>