<?php
/**
*
* @author Shredder
* @version $Id$
* @copyright (c) 2013 www.phpbb-work.ru
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// The name of the mod to be displayed during installation.
$mod_name = 'DAP_INSTALL';

/*
* The name of the config variable which will hold the currently installed version
* UMIL will handle checking, setting, and updating the version itself.
*/
$version_config_name = 'dap_version';

// The language file which will be included when installing
$language_file = 'mods/info_acp_dap_mod';
$user->add_lang('mods/info_acp_dap_mod');

/*
* Optionally we may specify our own logo image to show in the upper corner instead of the default logo.
* $phpbb_root_path will get prepended to the path specified
* Image height should be 50px to prevent cut-off or stretching.
*/
// $logo_img = 'styles/prosilver/imageset/site_logo.gif';

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You must use correct version numbering.  Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
* The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
*/
$versions = array(
	'1.0.6' => array(
		'custom'	=> 'install_mod_info',

		'config_add' => array(
			array('dap_ip_check', '0', 0),
			array('dap_cookie_check', '0', 0),
			array('dap_post_forum_id', '2', 0),
			array('dap_email_notification', '0', 0),
			array('dap_pm_notification', '0', 0),
			array('dap_post_notification', '0', 0),
			array('dap_alert_user_id', '2', 0),
			array('dap_cookie_ban', '0', 0),
			array('dap_cookie_autoban', '0', 0),
			array('dap_cookie_ban_message', $user->lang['DAP_COOKIE_BAN_MESSAGE_TEXT'], 0),
			array('dap_cookie_reg_deny', '0', 0),
			array('dap_reg_deny_message', $user->lang['DAP_COOKIE_DENY_REGISTER_TEXT'], 0),
			array('dap_users_per_page', '25', 0),
		),

		'table_column_add' => array(
			array($table_prefix . 'users', 'user_double', array('BOOL', 0)),
			array($table_prefix . 'users', 'user_banned_cookie', array('BOOL', 0)),
			array($table_prefix . 'users', 'ip_common_names', array('TEXT', '')),
			array($table_prefix . 'users', 'c_common_names', array('TEXT', '')),
		),

		'module_add' => array(
			array('acp', 'ACP_CAT_DOT_MODS', 'ACP_CAT_DAP_MOD'),
			array('acp', 'ACP_CAT_DAP_MOD', array(
					'module_basename'	=> 'dap',
					'module_langname'	=> 'ACP_DAP_SETTINGS',
					'module_mode'		=> 'settings',
					'module_auth'		=> 'acl_a_board',
				),
			),
			array('acp', 'ACP_CAT_DAP_MOD', array(
					'module_basename'	=> 'dap',
					'module_langname'	=> 'ACP_DAP_DUPE_USER_LIST',
					'module_mode'		=> 'dupe_user_list',
					'module_auth'		=> 'acl_a_board',
				),
			),
			array('acp', 'ACP_CAT_DAP_MOD', array(
					'module_basename'	=> 'dap',
					'module_langname'	=> 'ACP_DAP_DUPE_LOG',
					'module_mode'		=> 'dupe_log',
					'module_auth'		=> 'acl_a_viewlogs',
				),
			),
			array('acp', 'ACP_CAT_DAP_MOD', array(
					'module_basename'	=> 'dap',
					'module_langname'	=> 'ACP_DAP_BLACKLIST',
					'module_mode'		=> 'dap_blacklist',
					'module_auth'		=> 'acl_a_ban',
				),
			),
		),
	),

	'1.0.7' => array(
		'config_add' => array(
			array('dap_log_excluded', '0', 0),
		),
	),

	'1.0.8' => array(
		'config_remove' => 'dap_log_excluded',

		'table_add' => array(
			array($table_prefix . 'dap_log_excludes', array(
				'COLUMNS'		=> array(
					'user_id'	=> array('UINT', '0'),
					'exclude_id'	=> array('UINT', '0'),
				),

				'PRIMARY_KEY'	=> array('user_id', 'exclude_id')
				),
			),
		),
	),

	'1.0.9' => array(
		'custom'	=> 'dap_custom_install',
	),

	'1.0.10' => array(
		'config_add' => array(
			array('dap_ignore_inactive', '0', 0),
			array('dap_quick_deletion', '0', 0),
		),

		'permission_add' => array(
			array('a_cleardupe', 1),
		),
	),

	'1.0.11' => array(
		'config_add' => array(
			array('dap_user_notes_entry', '0', 0),
		),

		'custom'	=> 'convert_notify_forums',

		'config_remove' => 'dap_post_notification',

		'cache_purge' => array(),
	),

	'1.0.12' => array(
	),

	'1.0.13' => array(
	),
);

// Update to 1.0.9
function dap_custom_install($action, $version)
{
	global $db, $umil;

	switch ($version)
	{
		case '1.0.9' :
			if ($action == 'update')
			{
				$umil->umil_start('FIXING_PERMISSIONS');
				$db->sql_query('UPDATE ' . MODULES_TABLE . " SET module_auth = 'acl_a_viewlogs' WHERE module_basename = 'dap' AND module_mode = 'dupe_log'");
				$db->sql_query('UPDATE ' . MODULES_TABLE . " SET module_auth = 'acl_a_ban' WHERE module_basename = 'dap' AND module_mode = 'dap_blacklist'");
				$umil->umil_end();
			}
		break;
	}
}

// Update to 1.0.11
function convert_notify_forums($action, $version)
{
	global $config;

	switch ($version)
	{
		case '1.0.11' :
			if ($action == 'install' || $action == 'update')
			{
				$dap_post_forum_id = ($config['dap_post_notification']) ? $config['dap_post_forum_id'] : '';

				set_config('dap_post_forum_id', $dap_post_forum_id);
			}
		break;
	}
}

// Support info
function install_mod_info()
{
	return 'ACP_CAT_DAP_MOD_EXPLAIN';
}

// Include the UMIL Auto file, it handles the rest
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

?>